LeetCode#594: LongestHarmoniousSubsequence

Description

We define a harmonious array is an array where the difference between its maximum value and its minimum value is exactly 1.

Now, given an integer array, you need to find the length of its longest harmonious subsequence among all its possible subsequences.

Example

Example 1:
Input: [1,3,2,2,5,2,3,7]
Output: 5
Explanation: The longest harmonious subsequence is [3,2,2,2,3].

Note

  • The length of the input array will not exceed 20,000.

Solution

根据题意可知,harmonious子序列里面肯定只有两个值,这时候才能满足最大值与最小值相差为1。因此,我们可以使用HashMap将每个值出现的次数记录下来,相邻两个差为1的且出现次数和最大的两个值即为harmonious最长子序列里的值。例如:

输入:[1,3,2,2,5,2,3,7]
Map:
值:       1 2 3 5 7
---------------------
出现次数:  1 3 2 1 1

2和3之间相差1,且出现次数为3+2=5是最大的,所以harmonious最长子序列为[3,2,2,2,3]

class Solution {
    public int findLHS(int[] nums) {
    	if(nums == null || nums.length == 0)
    		return 0;
        HashMap<Integer, Integer> map = new HashMap<>();
        int max = 0;
        for(int i = 0; i < nums.length; i++) {
        	map.put(nums[i], map.getOrDefault(nums[i], 0)+1);
        }
        for(Map.Entry<Integer, Integer> entry : map.entrySet()) {
        	int key = entry.getKey();
        	int val = entry.getValue();
        	if(map.containsKey(key+1)) {
        		max = max > val + map.get(key+1) ? max : val + map.get(key+1);
        	}
        }
        return max;
    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值